'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var isClient = typeof document !== 'undefined';

var onClient = function onClient(cb) {
  if (isClient) cb(require('react-ga'));
};

var getLocationPath = function getLocationPath(location) {
  return location.pathname + location.search;
};

var logPageView = function logPageView(page) {
  onClient(function (ReactGA) {
    ReactGA.set({ page: page });
    ReactGA.pageview(page);
  });
};

var TrackPageViews = (function (_React$Component) {
  _inherits(TrackPageViews, _React$Component);

  function TrackPageViews() {
    _classCallCheck(this, TrackPageViews);

    return _possibleConstructorReturn(this, (TrackPageViews.__proto__ || Object.getPrototypeOf(TrackPageViews)).apply(this, arguments));
  }

  _createClass(TrackPageViews, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      onClient(function (ReactGA) {
        return ReactGA.initialize(_this2.props.trackingId);
      });

      var page = getLocationPath(this.props.location);
      logPageView(page);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var currentPage = getLocationPath(this.props.location);
      var nextPage = getLocationPath(nextProps.location);

      if (currentPage !== nextPage) {
        logPageView(nextPage);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children;
    }
  }]);

  return TrackPageViews;
})(_react2.default.Component);

TrackPageViews.propTypes = {
  children: _propTypes2.default.node.isRequired,
  trackingId: _propTypes2.default.string.isRequired
};

exports.default = (0, _reactRouterDom.withRouter)(TrackPageViews);