'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var srcSet = function srcSet(srcs, naturalWidth) {
  return srcs.map(function (src, index) {
    return src + ' ' + naturalWidth * (index + 1) + 'w';
  }).join(', ');
};

var RetinaImage = function RetinaImage(_ref) {
  var naturalWidth = _ref.naturalWidth,
      srcs = _ref.srcs,
      restProps = _objectWithoutProperties(_ref, ['naturalWidth', 'srcs']);

  return(
    // eslint-disable-next-line jsx-a11y/alt-text
    _react2.default.createElement('img', _extends({}, restProps, {
      src: srcs[0],
      srcSet: srcSet(srcs, naturalWidth),
      sizes: '(min-width: ' + naturalWidth + 'px) ' + naturalWidth + 'px, 100vw'
    }))
  );
};

RetinaImage.propTypes = {
  naturalWidth: _propTypes2.default.number.isRequired,
  srcs: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired
};

exports.default = RetinaImage;